<?php

Yii::import('application.modules.core_models.models._base.BasePasswordModel');

/**
 * This is the model base class for the table "user".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "User".
 *
 * Columns in table "user" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $username
 * @property string $secret
 *
 */
abstract class BaseUser extends BasePasswordModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'user';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'User|Users', $n);
    }

    public static function representingColumn()
    {
        return 'username';
    }

    public function rules()
    {
        return array(
            array('secret', 'required'),
            array('secret', 'length', 'max' => 60),
            array('username', 'length', 'max' => 255),
            array('username', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, username', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'username' => Yii::t('app', 'Username'),
            'secret' => 'Secret',
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('username', $this->username, true);
        $criteria->compare('secret', $this->secret, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
